#include <iostream>
#include <string.h>
#include <stdlib.h> 

using namespace std;

// numero de alunos para teste
#define N_ALUNOS 2


//struct com as informaes de cada aluno
struct aluno {
	char nome[50];
	int senha;
	int matricula;
	int id;
	float credito;
	int categoria;
} alunos[N_ALUNOS];

void mostraaluno(aluno student);

void mostraaluno(aluno student)
{
	cout << student.nome << "\n";
	cout << student.matricula << "\n";	
}

void main()
{
	//variaveis do programa
	int sensor = 0;
	char buffer[50];
	int n, n_aux, matricula_aux, senha_aux;
	int senha_ok = 0;
	int trava_catraca = 1;//catraca inicia travada

	cout << "\nEntrando com informacoes" << endl;

	//aquisio dos dados 
	for (n = 0; n<N_ALUNOS; n++)
	{
		cout << "Nome do Aluno " << n <<": ";
		cin.getline(alunos[n].nome, 50);
		cout << "Matricula: ";
		cin.getline(buffer, 50);
		alunos[n].matricula = atoi(buffer);
		cout << "Senha: ";
		cin.getline(buffer, 50);
		alunos[n].senha = atoi(buffer);
		cout << "Credito: ";
		cin.getline(buffer, 50);
		alunos[n].credito = atoi(buffer);
		cout << "Categoria(0 = estudante, 1 = isento, 2 = servidor, 3 = Visitante): ";
		cin.getline(buffer, 50);
		alunos[n].categoria = atoi(buffer);
		alunos[n].id = n;
	}

	while (sensor == 0)
	{
		//simulao de sensor de presensa para saber se alguem est proximo da catraca, 1 = pessoa detectada e 0 = ninguem
		cout << "\nAguardando usuario....(1 = pessoa detectada ou 0 = ninguem)" << endl;
		cin >> sensor;

		while ((senha_ok == 0) && (sensor == 1))
		{
			//simulao como se a pessoa apenas utilizasse a carteirinha do RU
			cout << "\nPor favor, insira seu carto identificador.(digitar matricula)" << endl;
			cin >> matricula_aux;

			//pessoa insere a senha cadastrada
			cout << "\nPor favor digite sua senha..." << endl;
			cin >> senha_aux;

			for (n = 0; n < N_ALUNOS; n++)
			{
				//teste se matricula e senha "combinam"
				if ((matricula_aux == alunos[n].matricula) && (senha_aux == alunos[n].senha))
				{
					senha_ok = 1; 
					n_aux = n; //salva o n que  salvo no ID, para saber qual aluno
				}
			}
			if (senha_ok == 0)
			{
				cout << "\nSenha ou matrcula incorreta." << endl;
			}
			else
			{
				cout << "\nSenha correta." << endl;

				//swith para verificar os creditor e fazer a cobrana, dependendo da categoria da pessoa
				switch (alunos[n_aux].categoria)
				{
					//estudante
				case 0:

					if (alunos[n_aux].credito >= 1.5)
					{
						alunos[n_aux].credito = alunos[n_aux].credito - 1.5;//cobra credito
						cout << "\nCreditos restantes " << alunos[n_aux].credito << " reais." << endl;
						trava_catraca = 0;//destrava catraca
					}
					else
					{
						cout << "\nCreditos insuficientes. " << endl;
					}
					break;
					//isento
				case 1:
					cout << "\nUsuario isento. " << endl;
					trava_catraca = 0;//destrava catraca

					break;
					//servidor
				case 2:

					if (alunos[n_aux].credito >= 2.9)
					{
						alunos[n_aux].credito = alunos[n_aux].credito - 2.9;//cobra credito
						cout << "\nCreditos restantes " << alunos[n_aux].credito << " reais." << endl;
						trava_catraca = 0;//destrava catraca
					}
					else
					{
						cout << "\nCreditos insuficientes. " << endl;
					}
					break;
					//visitante
				case 3:
					if (alunos[n_aux].credito >= 6.1)
					{
						alunos[n_aux].credito = alunos[n_aux].credito - 6.1;//cobra credito
						cout << "\nCreditos restantes " << alunos[n_aux].credito << " reais." << endl;
						trava_catraca = 0;//destrava catraca
					}
					else
					{
						cout << "\nCreditos insuficientes. " << endl;
						
					}
					break;

				}

				//trava da catraca
				if (trava_catraca == 0)
				{
					cout << "\nAcesso liberado. " << endl;
					
					while (sensor == 1)
					{
						cout << "\nAguardando saida do usuario....(pessoa passou pela catraca = 0, nao passou = 1)" << endl;
						cin >> sensor;
					}
					trava_catraca = 1;//trava catraca
					senha_ok = 0; //reseta a flag da senha_ok
				}
				else
				{
					cout << "\nAcesso negado. " << endl;
					senha_ok = 0;//reseta a flag da senha_ok
				}


			}
		}
	}
}